Avaya Client Services API Reference (iOS)

- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

Instance Methods | Properties | List of all members
CSCallFeatureService Class Reference

The CSCallFeatureService object is accessible from the CSUser object, providing access to additional business communication features. More...

`#import <CSCallFeatureService.h>`

Inherits NSObject.

## Instance Methods
(NSArray *) | - availableFeatures
| Gets all the calls features available to the user. More...
(NSArray *) | - availableBusyIndicators
| Gets all the busy indicators available to the user. More...
(NSArray *) | - availableAutodials
| Gets all the autodials available to the user. More...
(NSArray< CSFeatureStatusParameters * > *) | - availableHuntGroupBusyPositionFeatures
| Gets a list of configured hunt-group-busy-position feature buttons for the user. More...
(void) | - updateAutodial:completionHandler:
| Sends out a request in the network to update a configured Autodial button. More...
(BOOL) | - isFeatureAvailable:
| Returns a Boolean value indicating whether the specified feature is available. More...
(CSCapability *) | - capabilityForFeature:
| Returns a capability object indicating whether the specified feature is available. More...
(CSFeatureStatusParameters *) | - featureStatusParametersForType:withExtension:
| Returns feature status parameters for a specified extension and feature type. More...
(CSFeatureStatusParameters *) | - featureStatusParametersForFeature:
| Returns feature status parameters for a specified CSFeatureParameters object. More...
(void) | - invokeFeature:completionHandler:
| Invokes a feature that takes no parameters. More...
(void) | - invokeFeature:parameters:completionHandler:
| Invokes a feature. More...
(CSCapability *) | - sendAllCallsCapabilityForExtension:
| A capability object indicating whether the send all calls feature is available for the specified extention. More...
(BOOL) | - isSendAllCallsEnabledForExtension:
| Returns a Boolean value indicating whether the send all calls feature is enabled for the specified extension. More...
(void) | - setSendAllCallsEnabled:completionHandler:
| Enables or disables sending all calls to coverage. More...
(void) | - setSendAllCallsEnabled:forExtension:completionHandler:
| Enables or disables sending all calls to coverage for another extension. More...
(CSCapability *) | - callForwardingCapabilityForExtension:
| A capability object indicating whether the call forwarding feature is available for the specified extension. More...
(BOOL) | - isCallForwardingEnabledForExtension:
| Returns a Boolean value indicating whether the call forwarding feature is enabled for the specified extension. More...
(NSString *) | - callForwardingDestinationForExtension:
| Returns the call forwarding destination for the specified extension, if any. More...
(void) | - setCallForwardingEnabled:destination:completionHandler:
| Enables or disables forwarding of all calls to the specified destination. More...
(void) | - setCallForwardingEnabled:forExtension:destination:completionHandler:
| Enables or disables forwarding of all calls to the specified destination for another extension. More...
(CSCapability *) | - callForwardingBusyNoAnswerCapabilityForExtension:
| A capability object indicating whether the call forwarding busy-no-answer feature is available for the specified extension. More...
(BOOL) | - isCallForwardingBusyNoAnswerEnabledForExtension:
| Returns a Boolean value indicating whether the call forwarding busy-no-answer feature is enabled for the specified extension. More...
(NSString *) | - callForwardingBusyNoAnswerDestinationForExtension:
| Returns the call forwarding busy-no-answer destination for the specified extension, if any. More...
(void) | - setCallForwardingBusyNoAnswerEnabled:destination:completionHandler:
| Enables or disables forwarding of calls that receive a busy signal or are not answered to the specified destination. More...
(void) | - setCallForwardingBusyNoAnswerEnabled:forExtension:destination:completionHandler:
| Enables or disables forwarding of calls that receive a busy signal or are not answered to the specified destination for another extension. More...
(CSCapability *) | - enhancedCallForwardingCapabilityForExtension:
| A capability object indicating whether the Enhanced Call Forwarding feature is available for the specified extension. More...
(CSEnhancedCallForwardingStatus *) | - enhancedCallForwardingStatusForExtension:
| Returns the Enhanced Call Forwarding status for the specified extension. More...
(void) | - setEnhancedCallForwardingStatus:completionHandler:
| Sets the Enhanced Call Forwarding status for the user's local extension. More...
(void) | - setEnhancedCallForwardingStatus:forExtension:completionHandler:
| Sets the Enhanced Call Forwarding status for another extension. More...
(void) | - limitCalls:completionHandler:
| Enables or disables Limit Number of Concurrent Calls feature. More...
(void) | - setExclusionEnabled:completionHandler:
| Enables or disables exclusion for the active call. More...
(void) | - setEC500Enabled:completionHandler:
| Enables or disables EC500. More...
(void) | - setEC500Enabled:withDestinationNumber:completionHandler:
| Enables EC500 with the mobile phone number provided or disables EC500. More...
(void) | - extendCallWithCompletionHandler:
| Extends the active call to the off-pbx destinations configured for the user's extension, namely EC500. More...
(void) | - cancelExtendCallWithCompletionHandler:
| Cancels a pending extension of the active call to the off-pbx destinations configured for the user's extension. More...
(void) | - parkCallWithCompletionHandler:
| Parks the active call. More...
(void) | - parkCallToSlot:WithCompletionHandler:
| Parks the active call to a park slot. More...
(void) | - unparkCallWithCompletionHandler:
| Unparks a call previously parked at the user's extension. More...
(void) | - unparkCallAtExtension:completionHandler:
| Unparks a call previously parked at the specified extension. More...
(void) | - unparkCallFromSlot:WithCompletionHandler:
| Unparks the call from a park slot. More...
(BOOL) | - isAutoCallbackEnabledForDestination:
| A Boolean value indicating whether auto callback feature is enabled for the specified destination. More...
(void) | - setAutoCallbackEnabled:completionHandler:
| Enables an automatic callback for the last call if it received a busy signal or was unanswered. More...
(void) | - setAutoCallbackEnabled:forDestination:completionHandler:
| Enables or disables automatic callback for the specified destination. More...
(void) | - whisperPageToExtension:completionHandler:
| Starts a whisper page to another user that is on an active call. More...
(void) | - pickupCallAtExtension:completionHandler:
| Picks up a call ringing at the specified extension (directed call pickup). More...
(void) | - pickupGroupCallWithCompletionHandler:
| Picks up a call for the user's pickup group (group call pickup). More...
(void) | - pickupCallForGroup:completionHandler:
| Picks up a call for the specified pickup group (extended group call pickup). More...
(void) | - blockCallingPartyNumberToDestination:completionHandler:
| Starts a call to the specified destination with the user's calling party number information blocked if the call is made over a trunk. More...
(void) | - unblockCallingPartyNumberToDestination:completionHandler:
| Starts a call to the specified destination with the user's calling party number information unblocked if it would normally be blocked. More...
(void) | - startPriorityCallToDestination:completionHandler:
| Starts a priority call to the specified destination. More...
(void) | - completePreemptionForCall:completionHandler:
| Completes call preemption after user acknowledges the continuous preemption tone. More...
(void) | - setHuntGroupBusyPositionEnabled:forHuntGroup:completionHandler:
| Enables or Disables Hunt Group Busy Position feature for a specified hunt group number. More...
(void) | - setPersonalizedLabel:forFeature:completionHandler:
| Updates the feature with personalized label given by user. More...
(CSCapability *) | - huntGroupBusyPositionCapabilityForHuntGroupNumber:
| A capability object indicating whether the hunt-group-busy-position feature is available for the specified hunt group number. More...
(void) | - activateMaliciousCallTraceWithCompletionHandler:
| Activate Malicious Call Trace feature for incoming active call. More...
(void) | - makeNoHoldConferenceWithDestination:completionHandler:
| Start No Hold Conference for active call, or add new participant to existing conference. More...
(void) | - cancelNoHoldConferenceWithCompletionHandler:
| Cancels the No Hold Conference invocation. More...
(void) | - startServiceObserving:withType:withLocation:completionHandler:
| Starts service observing. More...
(void) | - changeServiceObservingMode:completionHandler:
| Change the mode of service observing session. More...
(void) | - stopCoachingSession:
| Stop coaching and move the service observing session to previous mode. More...
(void) | - stopServiceObserving:
| Stops service observing. More...
(CSCapability *) | - callRecordingCapabilityForActionType:
| Returns a capability object indicating whether a particular call recording action is allowed. More...
(void) | - performCallRecordingWithActionType:completionHandler:
| Perform call recording operation with specific action type. More...
(void) | - moveCall:
| Call Handover to move a call to user's simultaneous/twin clients. More...
(void) | - retrieveCall:
| Call Handover to retrieve a call from user's simultaneous/twin clients. More...
(void) | - setSimRingCallbackStatusParameters:completionHandler:
| Enables or disables the callback / simultaneous ring feature with the specified parameters. More...
(void) | - invokeCallbackCallFromDestination:toRemoteAddress:completionHandler:
| Initiates/places a call from the callback destination to the remote address. More...
(void) | - invokeCallbackCallToRemoteAddress:completionHandler:
| Initiates/places a call to the remote address. More...
(void) | - invokeSendNNCallWithExtension:toRemoteAddress:completionHandler:
| Initiates/places a call to the remote address with send-nn. More...
(void) | - setSendNNEnabled:forExtension:completionHandler:
| Enables or disables send-nn for the specified extension. More...

## Properties
id< CSCallFeatureServiceDelegate > | delegate
| The delegate responsible for handling call feature events. More...
BOOL | isServiceAvailable
| A Boolean value indicating whether the Call Feature Service is available. More...
CSCapability * | sendAllCallsCapability
| A capability object indicating whether the send all calls feature is available for the user's local extension. More...
BOOL | sendAllCallsEnabled
| A Boolean value indicating whether the send all calls feature is enabled for the user's local extension. More...
CSCapability * | callForwardingCapability
| A capability object indicating whether the call forwarding feature is available for the user's local extension. More...
BOOL | callForwardingEnabled
| A Boolean value indicating whether the call forwarding feature is enabled for the user's local extension. More...
NSString * | callForwardingDestination
| The call forwarding destination for the user's local extension, if any. More...
BOOL | internalTwinningEnabled
| A Boolean value indicating whether the internal twinning feature is enabled. More...
CSCapability * | callForwardingBusyNoAnswerCapability
| A capability object indicating whether the call forwarding busy-no-answer feature is available for the user's local extension. More...
BOOL | callForwardingBusyNoAnswerEnabled
| A Boolean value indicating whether the call forwarding busy-no-answer feature is enabled for the user's local extension. More...
NSString * | callForwardingBusyNoAnswerDestination
| The call forwarding busy-no-answer destination for the user's local extension, if any. More...
CSCapability * | enhancedCallForwardingCapability
| A capability object indicating whether the Enhanced Call Forwarding feature is available for the user's local extension. More...
CSEnhancedCallForwardingStatus * | enhancedCallForwardingStatus
| The Enhanced Call Forwarding status for the user's local extension, if any. More...
CSCapability * | limitCallsCapability
| A capability object indicating whether the Limit Number of Concurrent Calls feature is available. More...
CSCapability * | exclusionCapability
| A capability object indicating whether the exclusion feature is available. More...
CSCapability * | EC500Capability
| A capability object indicating whether the EC500 feature is available. More...
BOOL | EC500Enabled
| A Boolean value indicating whether the EC500 feature is enabled. More...
CSCapability * | extendCallCapability
| A capability object indicating whether the extend call feature is available. More...
CSCapability * | parkCallCapability
| A capability object indicating whether the call park feature is available. More...
CSCapability * | parkCallWithSlotCapability
| A capability object indicating whether the call park feature with park slot is available. More...
CSCapability * | unparkCallCapability
| A capability object indicating whether the call unpark feature with slot number is available. More...
CSCapability * | unparkCallWithSlotCapability
| A capability object indicating whether the call unpark feature with park slot is available. More...
CSCapability * | autoCallbackCapability
| A capability object indicating whether the auto callback feature is available. More...
BOOL | autoCallbackEnabled
| A Boolean value indicating whether the auto callback feature is enabled. More...
NSArray * | autoCallbackList
| The list of outstanding automatic callback destinations in case autoCallbackDestination capability is enabled, empty list otherwise. More...
CSCapability * | whisperPageCapability
| A capability object indicating whether the whisper page feature is available. More...
CSCapability * | pickupCallAtExtensionCapability
| A capability object indicating whether the directed call pickup feature is available. More...
CSCapability * | pickupGroupCallCapability
| A capability object indicating whether the group call pickup feature is available. More...
CSCapability * | pickupCallForGroupCapability
| A capability object indicating whether the extended group call pickup feature is available. More...
CSCapability * | blockCallingPartyNumberCapability
| A capability object indicating whether the block calling party number feature is available. More...
CSCapability * | unblockCallingPartyNumberCapability
| A capability object indicating whether the unblock calling party number feature is available. More...
CSCapability * | priorityCallCapability
| A capability object indicating whether the priority call feature is available. More...
NSArray< CSTeamButton * > * | teamButtons
| List of team buttons assigned to the station. More...
CSCapability * | maliciousCallTraceCapability
| A capability object indicating whether Malicious Call Trace feature is available for incoming active call. More...
BOOL | maliciousCallTraceActive
| A Boolean value indicating whether Malicious Call Trace feature is activated. More...
CSCapability * | noHoldConferenceCapability
| A capability object indicating whether No Hold Conference feature is available for active call. More...
CSCapability * | noHoldConferenceCancelCapability
| A capability object indicating whether No Hold Conference feature can be canceled. More...
NSString * | noHoldConferenceDestination
| The destination extension for No Hold Conference feature button. More...
CSServiceObservingStatusParameters * | serviceObservingStatusParameters
| Returns service observing feature status parameters. More...
CSCapability * | serviceObservingCapability
| Returns an indication as to whether the service observing is available. More...
CSCapability * | simRingCallbackCapability
| A capability object indicating whether the user is able to configure callback / simultaneous ring destinations and their parameters. More...
BOOL | simRingCallbackEnabled
| A Boolean value indicating whether the callback / simultaneous ring feature is enabled. More...
CSSimRingCallbackStatusParameters * | simRingCallbackStatusParameters
| Returns callback / simultaneous ring feature status parameters. More...
CSCapability * | callbackCallCapability
| Returns a capability object indicating whether the user is able to invoke callback calls. More...
CSCapability * | sendNNCapability
| Returns a capability object indicating whether the user is able to invoke send-nn feature. More...

## Detailed Description

The CSCallFeatureService object is accessible from the CSUser object, providing access to additional business communication features.

The CSCallFeatureService object provides a set of APIs that allow application developers to implement advanced SIP telephony features.

In general, administered features can be invoked depending upon the current state of the system.

The client application is notified about status updates on features reported by the call feature service through handlers that the application has registered on the CSCallFeatureService object. These updates may be the result of local operations on the CSCallFeatureService object as well as remote changes initiated by either the service/server or other end users.

## Method Documentation

- (void) activateMaliciousCallTraceWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Activate Malicious Call Trace feature for incoming active call.

When malicious call trace controller (human) presses "mct-contr" button, callback didChangeMaliciousCallTraceStatus(true) is invoked. When the controller deactivates a malicious call trace, callback didChangeMaliciousCallTraceStatus(false) is invoked. Feature is deactivated by pressing the feature deactivation code by same client, which pressed "mct-contr" button. "mct-contr" button is implemented in CM for h.323 only.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (NSArray *) availableAutodials |  |  |

Gets all the autodials available to the user.

Returns
  An NSArray of CSAutodial objects.

- (NSArray *) availableBusyIndicators |  |  |

Gets all the busy indicators available to the user.

Returns
  An NSArray of CSBusyIndicator objects.

- (NSArray *) availableFeatures |  |  |

Gets all the calls features available to the user.

Returns
  An NSArray of CSFeatureStatusParameters objects describing the available features.

- (NSArray<CSFeatureStatusParameters *> *) availableHuntGroupBusyPositionFeatures |  |  |

Gets a list of configured hunt-group-busy-position feature buttons for the user.

Returns
  An NSArray of CSFeatureStatusParameters objects describing the available hunt-group-busy-position features.

- (void) blockCallingPartyNumberToDestination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Starts a call to the specified destination with the user's calling party number information blocked if the call is made over a trunk.

Parameters

  destination | The destination to call.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (CSCapability *) callForwardingBusyNoAnswerCapabilityForExtension: |  | (NSString *) | extension |

A capability object indicating whether the call forwarding busy-no-answer feature is available for the specified extension.

Parameters

  extension | The extension for which to query the availability of the feature.

- (NSString *) callForwardingBusyNoAnswerDestinationForExtension: |  | (NSString *) | extension |

Returns the call forwarding busy-no-answer destination for the specified extension, if any.

Parameters

  extension | The extension for which to query the forwarding destination.

- (CSCapability *) callForwardingCapabilityForExtension: |  | (NSString *) | extension |

A capability object indicating whether the call forwarding feature is available for the specified extension.

Parameters

  extension | The extension for which to query the availability of the feature.

- (NSString *) callForwardingDestinationForExtension: |  | (NSString *) | extension |

Returns the call forwarding destination for the specified extension, if any.

Parameters

  extension | The extension for which to query the forwarding destination.

- (CSCapability *) callRecordingCapabilityForActionType: |  | (CSCallRecordingActionType) | type |

Returns a capability object indicating whether a particular call recording action is allowed.

Parameters

  type | The call recording action type.

Returns
  CSCapability object describing whether the recording action is allowed.

See also
  CSCallRecordingActionType

- (void) cancelExtendCallWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Cancels a pending extension of the active call to the off-pbx destinations configured for the user's extension.

An invocation of `extendCallWithCompletionHandler:` is not considered successful until the call has been answered on one of the user's off-pbx destinations. Until this occurs `cancelExtendCallWithCompletionHandler:` may be used to cancel the pending extension of the active call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

See also
  - extendCallWithCompletionHandler:

- (void) cancelNoHoldConferenceWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Cancels the No Hold Conference invocation.

The feature can be canceled after invocation of No Hold Conference and during the time it's ringing on the party that is to be added to the No Hold Conference.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (CSCapability *) capabilityForFeature: |  | (CSFeatureType) | featureType |

Returns a capability object indicating whether the specified feature is available.

Parameters

  featureType | The feature to query.

- (void) changeServiceObservingMode: |  | (CSServiceObservingMode) | mode
completionHandler: |  | (void(^)(NSError *error)) | handler

Change the mode of service observing session.

Parameters

  mode | The Service Observing mode.
  handler | An Object that wants to learn about the result of change service observing mode operation i.e., whether it was successful.

See also
  CSServiceObservingMode

- (void) completePreemptionForCall: |  | (CSCall *) | preemptedCall
completionHandler: |  | (void(^)(NSError *error)) | handler

Completes call preemption after user acknowledges the continuous preemption tone.

Call preemption occurs when a precedence call is sent to a preemptable endpoint that is busy with a call of lower precedence and has no idle appearances. This causes the lower precedence call to be preempted, regardless of whether the lower precedence call and the new higher precedence call are of the same media type. When preemption occurs, the active busy user receive a continuous preemption tone until user acknowledges the preemption by invoking complete preemption method and the other party receives a preemption tone for a minimum of 3 seconds. After acknowledging the preemption, the extension to which the precedence call is directed will be provided with precedence ringing and the calling party will receive an audible ring-back precedence tone.

Application must start playing preemption tone upon receipt of event call:didPreempt:isPreemptionCompletionRequiredByClient: (CSCallDelegate-p) and stop preemption tone before calling completeCallPreemption when user acknowledges the preemption. However when other end receives preemption application must stop tone after 3 seconds and call:didPreempt:isPreemptionCompletionRequiredByClient: (CSCallDelegate-p) is NOT needed since there is no precedence call is directed at this end, other end is free and ready to receive any other new call while tone is being played.

Parameters

  preemptedCall | call which was preempted and received didPreempt event.
  handler | A completion handler that receives the result of the operation.

See also
  - call:didPreempt:isPreemptionCompletionRequiredByClient: (CSCallDelegate-p)

- (CSCapability *) enhancedCallForwardingCapabilityForExtension: |  | (NSString *) | extension |

A capability object indicating whether the Enhanced Call Forwarding feature is available for the specified extension.

Parameters

  extension | The extension for which to query the availability of the feature.

- (CSEnhancedCallForwardingStatus *) enhancedCallForwardingStatusForExtension: |  | (NSString *) | extension |

Returns the Enhanced Call Forwarding status for the specified extension.

Returns
  A CSEnhancedCallForwardingStatus object describing the busy, no reply, and unconditional call forwarding settings.

- (void) extendCallWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Extends the active call to the off-pbx destinations configured for the user's extension, namely EC500.

An invocation of `extendCallWithCompletionHandler:` is not considered successful until the call has been answered on one of the user's off-pbx destinations. Until this occurs `cancelExtendCallWithCompletionHandler:` may be used to cancel the pending extension of the active call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

See also
  - cancelExtendCallWithCompletionHandler:

- (CSFeatureStatusParameters *) featureStatusParametersForFeature: |  | (CSFeatureParameters *) | featureParams |

Returns feature status parameters for a specified CSFeatureParameters object.

If feature type is not configured for specified extension, this API will return empty object of type FeatureStatusParameters with CSFeatureStatusUndefined status in it. Other status are CSFeatureStatusOn/CSFeatureStatusOff/CSFeatureStatusAlerting.

Parameters

  featureParams | The CSFeatureParameters object to query feature status.

- (CSFeatureStatusParameters *) featureStatusParametersForType: |  | (CSFeatureType) | featureType
withExtension: |  | (NSString *) | ownerExtension

Returns feature status parameters for a specified extension and feature type.

If feature type is not configured for specified extension, this API will return empty object of type FeatureStatusParameters with CSFeatureStatusUndefined status in it. Other status are CSFeatureStatusOn/CSFeatureStatusOff/CSFeatureStatusAlerting.

Parameters

  featureType | The feature to query.
  ownerExtension | Extension number

This method is deprecated please use featureStatusParametersForFeature: .

- (CSCapability *) huntGroupBusyPositionCapabilityForHuntGroupNumber: |  | (NSInteger) | huntGroupNumber |

A capability object indicating whether the hunt-group-busy-position feature is available for the specified hunt group number.

Parameters

  huntGroupNumber | The hunt group number for which to query the availability of the feature.

- (void) invokeCallbackCallFromDestination: |  | (NSString *) | callbackDestination
toRemoteAddress: |  | (NSString *) | remoteAddress
completionHandler: |  | (void(^)(CSCallbackCallStatus status, NSError *error)) | handler

Initiates/places a call from the callback destination to the remote address.

See also
  CSCallFeatureService::invokeCallbackCallToRemoteAddress:completionHandler can be used if you don't want to specify the callback destination.

Parameters

  callbackDestination | The destination from where the call should be initiated. This must be one of the destinations configured via

See also
  - setSimRingCallbackStatusParameters:completionHandler:. If not specified, the call will be placed from the default callback destination configured via
  - setSimRingCallbackStatusParameters:completionHandler: or saved from the last callback call invocation. The specified callback destination is saved as the default callback destination automatically after placing a callback call. It will override previously configured default callback destination if any.

Parameters

  remoteAddress | The destination that the call should be addressed to.
  handler | A block to be called when the operation is completed. `status` If the operation was finished, this parameter is CSCallbackCallStatusUndefined. If an intermediate event occured, it contains a callback call status (

See also
  CSCallbackCallStatus).
  - `error` If the operation was successful or an intermediatr event happened, this parameter is nil. If an error occurred it contains an object describing the error.

- (void) invokeCallbackCallToRemoteAddress: |  | (NSString *) | remoteAddress
completionHandler: |  | (void(^)(CSCallbackCallStatus status, NSError *error)) | handler

Initiates/places a call to the remote address.

The call will be placed from the default callback destination configured via

See also
  - setSimRingCallbackStatusParameters:completionHandler: or saved from the last callback call invocation
  CSCallFeatureService::invokeCallbackCallFromDestination:toRemoteAddress:completionHandler. If the default callback destination is not specified, an error will be returned.

Parameters

  remoteAddress | The destination that the call should be addressed to.
  handler | A block to be called when the operation is completed. `status` If the operation was finished, this parameter is CSCallbackCallStatusUndefined. If an intermediate event occured, it contains a callback call status (

See also
  CSCallbackCallStatus).
  - `error` If the operation was successful or an intermediatr event happened, this parameter is nil. If an error occurred it contains an object describing the error.

- (void) invokeFeature: |  | (CSFeatureType) | featureType
completionHandler: |  | (void(^)(NSError *error)) | handler

Invokes a feature that takes no parameters.

Parameters

  featureType | The feature to invoke.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) invokeFeature: |  | (CSFeatureType) | featureType
parameters: |  | (CSFeatureInvocationParameters *) | featureParameters
completionHandler: |  | (void(^)(NSError *error)) | handler

Invokes a feature.

Feature Parameters
---------------------------------------------------------------------------------
CSFeatureTypeSendAllCalls [action] [owner-extension]
CSFeatureTypeForwardAllCalls [action] [destination] [owner-extension]
CSFeatureTypeForwardBusyNoAnswerCalls [action] [destination] [owner-extension]
CSFeatureTypeExclusion [action]
CSFeatureTypeEC500 [action]
CSFeatureTypeExtendCall
CSFeatureTypeCallPark
CSFeatureTypeCallUnpark [extension]
CSFeatureTypeAutoCallback [action]
CSFeatureTypeWhisperPage [extension]
CSFeatureTypeGroupCallPickup
CSFeatureTypeExtendedGroupCallPickup [pickup-number]
CSFeatureTypeCallingPartyNumberBlock [destination]
CSFeatureTypeCallingPartyNumberUnblock [destination]
CSFeatureTypeOneTouchRecording [action] [extension]
CSFeatureTypeDirectedCallPickup [extension]
CSFeatureTypePriorityCall [destination]
CSFeatureTypeHuntGroupBusyPosition [action] [hunt-group number]
CSFeatureTypeMaliciousCallTrace
CSFeatureTypeNoHoldConference [destination]
CSFeatureTypeLimitCalls [action]
CSFeatureTypeSimRingCallback [sim-ring-callback-parameters]
CSFeatureTypeCallbackCall [extension] [destination]

Parameters

  featureType | The feature to invoke.
  featureParameters | The parameters supporting this feature invocation.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) invokeSendNNCallWithExtension: |  | (NSString *) | extension
toRemoteAddress: |  | (NSString *) | remoteAddress
completionHandler: |  | (void(^)(NSError *error)) | handler

Initiates/places a call to the remote address with send-nn.

The call will be placed with the specified extension as the caller's number. Use this method only if FeatureMode is transient.

See also
  CSFeatureMode

use

See also
  - setSendNNEnabled:forExtension:completionHandler: when the feature mode is PERMANENT

Parameters

  extension | The number to be used by caller as his/her number/identity while placing the outgoing call.
  remoteAddress | The destination that the call should be addressed to.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (BOOL) isAutoCallbackEnabledForDestination: |  | (NSString *) | destination |

A Boolean value indicating whether auto callback feature is enabled for the specified destination.

Use this method only if AutoCallback destination is editable, otherwise use CSCallFeatureService::autoCallbackEnabled property.

See also
  CSFeatureStatusParameters::isDestinationExtensionEditable

Parameters

  destination | The destination to query auto-callback enablement for.

- (BOOL) isCallForwardingBusyNoAnswerEnabledForExtension: |  | (NSString *) | extension |

Returns a Boolean value indicating whether the call forwarding busy-no-answer feature is enabled for the specified extension.

Parameters

  extension | The extension for which to query the status of the feature.

- (BOOL) isCallForwardingEnabledForExtension: |  | (NSString *) | extension |

Returns a Boolean value indicating whether the call forwarding feature is enabled for the specified extension.

Parameters

  extension | The extension for which to query the status of the feature.

- (BOOL) isFeatureAvailable: |  | (CSFeatureType) | featureType |

Returns a Boolean value indicating whether the specified feature is available.

Parameters

  featureType | The feature to query.

- (BOOL) isSendAllCallsEnabledForExtension: |  | (NSString *) | extension |

Returns a Boolean value indicating whether the send all calls feature is enabled for the specified extension.

Parameters

  extension | The extension for which to query the status of the feature.

- (void) limitCalls: |  | (BOOL) | enabled
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables Limit Number of Concurrent Calls feature.

Limit Number of Concurrent Calls feature: Users can use this to limit the number of concurrent calls at a station to one call, where normally multiple call appearances can terminate at the station.

Parameters

  enabled | If `YES` Limit Number of Concurrent Calls is enabled. If `NO` Limit Number of Concurrent Calls is disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) makeNoHoldConferenceWithDestination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Start No Hold Conference for active call, or add new participant to existing conference.

No Hold Conference feature button allows a user to set up a conference call without interrupting the current conversation. The called party is automatically added to the conference as soon as they answer. Successful completionHandler is invoked after invited party answered, or the feature was canceled. Current active call will be transformed into the conference. The number dialed by the user is sent as a message and not as tone so that the digits are not heard by any party on the call. So No Hold Conference button should be used if it's important that no tones are heard by participants, and/or remote user should not be held. In other cases AddParticipantFromCall/AddParticipant methods of Conference interface should be used. No Hold Conference is Avaya Communication Manager feature, which is not available in other environments.

Parameters

  destination | Network address of the person who is being added to the conference call.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) moveCall: |  | (void(^)(NSError *error)) | handler |

Call Handover to move a call to user's simultaneous/twin clients.

Parameters

  handler | An Object that wants to learn about the result of call handover operation i.e., whether it was successful.

- (void) parkCallToSlot: |  | (NSString *) | parkSlot
WithCompletionHandler: |  | (void(^)(NSError *error)) | handler

Parks the active call to a park slot.

A parked call may later be unparked from another extension using the park slot.

Parameters

  parkSlot | A park slot where the call should be parked The minimum length of the park slot is 1, and the maximum length is 9. Characters in this field would normally be 0-9, ‘::’ ‘*’.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) parkCallWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Parks the active call.

A parked call may later be unparked from another extension.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) performCallRecordingWithActionType: |  | (CSCallRecordingActionType) | type
completionHandler: |  | (void(^)(NSError *error)) | handler

Perform call recording operation with specific action type.

Parameters

  type | The call recording action type.
  handler | An Object that wants to learn about the result of call recording operation i.e., whether it was successful.

See also
  CSCallRecordingActionType

- (void) pickupCallAtExtension: |  | (NSString *) | extension
completionHandler: |  | (void(^)(NSError *error)) | handler

Picks up a call ringing at the specified extension (directed call pickup).

Parameters

  extension | The extension to pick up the call from.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) pickupCallForGroup: |  | (NSInteger) | groupNumber
completionHandler: |  | (void(^)(NSError *error)) | handler

Picks up a call for the specified pickup group (extended group call pickup).

Parameters

  groupNumber | The group number to pick up the call from.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) pickupGroupCallWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Picks up a call for the user's pickup group (group call pickup).

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) retrieveCall: |  | (void(^)(NSError *error)) | handler |

Call Handover to retrieve a call from user's simultaneous/twin clients.

Parameters

  handler | An Object that wants to learn about the result of call handover operation i.e., whether it was successful.

- (CSCapability *) sendAllCallsCapabilityForExtension: |  | (NSString *) | extension |

A capability object indicating whether the send all calls feature is available for the specified extention.

Parameters

  extension | The extension for which to query the availability of the feature.

- (void) setAutoCallbackEnabled: |  | (BOOL) | enabled
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables an automatic callback for the last call if it received a busy signal or was unanswered.

When the station becomes able to receive a call the user who invoked this feature will be called back automatically.

Parameters

  enabled | If `YES` automatic callback is enabled. If `NO` automatic callback is disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setAutoCallbackEnabled: |  | (BOOL) | enabled
forDestination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables automatic callback for the specified destination.

When the destination user becomes able to receive a call the user who invoked this feature will be called back automatically. Use this method only if autoCallback destination is editable, otherwise use setAutoCallbackEnabled:completionHandler: method.

See also
  CSFeatureStatusParameters::isDestinationExtensionEditable

Parameters

  enabled | If `YES` automatic callback is enabled. If `NO` automatic callback is disabled.
  destination | The destination to enable auto-callback for.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setCallForwardingBusyNoAnswerEnabled: |  | (BOOL) | enabled
destination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables forwarding of calls that receive a busy signal or are not answered to the specified destination.

Parameters

  enabled | If `YES` forwarding is enabled. If `NO` forwarding is disabled.
  destination | The destination number to forward calls to.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setCallForwardingBusyNoAnswerEnabled: |  | (BOOL) | enabled
forExtension: |  | (NSString *) | extension
destination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables forwarding of calls that receive a busy signal or are not answered to the specified destination for another extension.

Parameters

  enabled | If `YES` forwarding is enabled. If `NO` forwarding is disabled.
  extension | The extension to update call forwarding settings for.
  destination | The destination number to forward calls to.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setCallForwardingEnabled: |  | (BOOL) | enabled
destination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables forwarding of all calls to the specified destination.

Parameters

  enabled | If `YES` forwarding is enabled. If `NO` forwarding is disabled.
  destination | The destination number to forward calls to.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setCallForwardingEnabled: |  | (BOOL) | enabled
forExtension: |  | (NSString *) | extension
destination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables forwarding of all calls to the specified destination for another extension.

Parameters

  enabled | If `YES` forwarding is enabled. If `NO` forwarding is disabled.
  extension | The extension to enable or disable forwarding for.
  destination | The destination number to forward calls to.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setEC500Enabled: |  | (BOOL) | enabled
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables EC500.

Parameters

  enabled | If `YES` EC500 is enabled. If `NO` EC500 is disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setEC500Enabled: |  | (BOOL) | enabled
withDestinationNumber: |  | (NSString *) | number
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables EC500 with the mobile phone number provided or disables EC500.

Use this method only if EC500 destination is editable, otherwise use setEC500Enabled:completionHandler: method.

See also
  CSFeatureStatusParameters::isDestinationExtensionEditable

Parameters

  enabled | If `YES` EC500 is enabled. If `NO` EC500 is disabled.
  number | A mobile phone number. The destination can be any external number the user is able to dial normally. It should include any prefix if necessary. The number is not relevant if enabled=false.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setEnhancedCallForwardingStatus: |  | (CSEnhancedCallForwardingStatus *) | enhancedCallForwardingStatus
completionHandler: |  | (void(^)(NSError *error)) | handler

Sets the Enhanced Call Forwarding status for the user's local extension.

Parameters

  enhancedCallForwardingStatus | The new enhanced call forwarding status, specifying the busy, no reply, and unconditional call forwarding settings. For IP Office, the same destination number should be provided for call forward busy and no reply.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setEnhancedCallForwardingStatus: |  | (CSEnhancedCallForwardingStatus *) | enhancedCallForwardingStatus
forExtension: |  | (NSString *) | extension
completionHandler: |  | (void(^)(NSError *error)) | handler

Sets the Enhanced Call Forwarding status for another extension.

Parameters

  enhancedCallForwardingStatus | The new enhanced call forwarding status, specifying the busy, no reply, and unconditional call forwarding settings. For IP Office, the same destination number should be provided for call forward busy and no reply.
  extension | The extension to update call forwarding settings for.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setExclusionEnabled: |  | (BOOL) | enabled
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables exclusion for the active call.

Exclusion prevents any other users from bridging onto the call, and drops any other users who are already bridged onto the call.

Parameters

  enabled | If `YES` exclusion is enabled. If `NO` exclusion is disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setHuntGroupBusyPositionEnabled: |  | (BOOL) | enabled
forHuntGroup: |  | (NSInteger) | huntGroupNumber
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or Disables Hunt Group Busy Position feature for a specified hunt group number.

When enabled, user will not receive any calls targeted for that hunt group. In order to receive calls on the hunt group, feature needs to be disabled again.

Parameters

  enabled | If `YES` hunt group busy position is enabled. If `NO` hunt group busy position is disabled.
  huntGroupNumber | The hunt group number for which feature is enabled or disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setPersonalizedLabel: |  | (NSString *) | featureLabel
forFeature: |  | (CSFeatureParameters *) | featureParams
completionHandler: |  | (void(^)(NSError *error)) | handler

Updates the feature with personalized label given by user.

Parameters

  featureLabel | The personalized label to be set.
  featureParams | The CSFeatureParameters object providing details about feature to update.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setSendAllCallsEnabled: |  | (BOOL) | enabled
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables sending all calls to coverage.

Parameters

  enabled | If `YES` send all calls is enabled. If `NO` send all calls is disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setSendAllCallsEnabled: |  | (BOOL) | enabled
forExtension: |  | (NSString *) | extension
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables sending all calls to coverage for another extension.

Parameters

  enabled | If `YES` send all calls is enabled. If `NO` send all calls is disabled.
  extension | The extension to enable or disable send all calls for.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setSendNNEnabled: |  | (BOOL) | enabled
forExtension: |  | (NSString *) | extension
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables send-nn for the specified extension.

Calls will be placed with the specified extension as the caller's number. Use this method only if FeatureMode is permanent.

See also
  CSFeatureMode

use

See also
  - invokeSendNNCallWithExtension:toRemoteAddress:completionHandler: when the feature mode is TRANSIENT

Parameters

  enabled | If `YES` send-nn is enabled. If `NO` send-nn is disabled.
  extension | The number to which, send-nn should be enabled/disabled.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) setSimRingCallbackStatusParameters: |  | (CSSimRingCallbackStatusParameters *) | simRingCallbackStatusParameters
completionHandler: |  | (void(^)(NSError *error)) | handler

Enables or disables the callback / simultaneous ring feature with the specified parameters.

Parameters

  simRingCallbackStatusParameters | The callback / simultaneous ring feature status parameters. To enable the feature at least 1 destination should be configured. All of the configured destinations must be unique. To disable the feature all of the destinations must be empty ("" or nil). The configured default callback destination in these parameters may also be overridden by the callback call feature invocation (

See also
  CSCallFeatureService::invokeCallbackCall:withRemoteAddress:completionHandler:).

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) startPriorityCallToDestination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Starts a priority call to the specified destination.

Priority calls have distinct alerting and typically do not go to coverage.

Parameters

  destination | The destination to call.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) startServiceObserving: |  | (NSString *) | entity
withType: |  | (CSServiceObservingType) | type
withLocation: |  | (NSInteger) | location
completionHandler: |  | (void(^)(NSError *error)) | handler

Starts service observing.

Service observing feature allows supervisors to monitor calls to extensions, agents or VDNs.

Parameters

  entity | The extension of the endpoint to be observed.
  type | The Service Observing type.
  location | The location number associated with the observed VDN. The valid range is 0-2000. The value 0 means that the service observing type is not "By Location" If the location number is outside the valid range, an error will be reported to the application via the supplied completion handler.
  handler | An Object that wants to learn about the result of start service observing operation i.e., whether it was successful.

See also
  CSServiceObservingType

- (void) stopCoachingSession: |  | (void(^)(NSError *error)) | handler |

Stop coaching and move the service observing session to previous mode.

If the service observing session is not in coaching mode, an error will be reported to the application via the supplied completion handler.

Parameters

  handler | An Object that wants to learn about the result of stop coaching session operation i.e., whether it was successful.

- (void) stopServiceObserving: |  | (void(^)(NSError *error)) | handler |

Stops service observing.

Parameters

  handler | An Object that wants to learn about the result of stop service observing operation i.e., whether it was successful.

- (void) unblockCallingPartyNumberToDestination: |  | (NSString *) | destination
completionHandler: |  | (void(^)(NSError *error)) | handler

Starts a call to the specified destination with the user's calling party number information unblocked if it would normally be blocked.

Parameters

  destination | The destination to call.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unparkCallAtExtension: |  | (NSString *) | extension
completionHandler: |  | (void(^)(NSError *error)) | handler

Unparks a call previously parked at the specified extension.

Parameters

  extension | The extension from which to retrieve the parked call.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unparkCallFromSlot: |  | (NSString *) | parkSlot
WithCompletionHandler: |  | (void(^)(NSError *error)) | handler

Unparks the call from a park slot.

Parameters

  parkSlot | A park slot from where the call should be unparked. The minimum length of the park slot is 1, and the maximum length is 9. Characters in this field would normally be 0-9, ‘::’ ‘*’.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unparkCallWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Unparks a call previously parked at the user's extension.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) updateAutodial: |  | (CSAutodial *) | updatedAutodial
completionHandler: |  | (void(^)(NSError *error)) | handler

Sends out a request in the network to update a configured Autodial button.

Parameters

  updatedAutodial | User modified autodial button
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) whisperPageToExtension: |  | (NSString *) | extension
completionHandler: |  | (void(^)(NSError *error)) | handler

Starts a whisper page to another user that is on an active call.

Parameters

  extension | The extension to start a whisper page to.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

## Property Documentation

- (CSCapability*) autoCallbackCapability
| read atomic assign

A capability object indicating whether the auto callback feature is available.

- (BOOL) autoCallbackEnabled
| read atomic assign

A Boolean value indicating whether the auto callback feature is enabled.

- (NSArray*) autoCallbackList
| read nonatomic assign

The list of outstanding automatic callback destinations in case autoCallbackDestination capability is enabled, empty list otherwise.

- (CSCapability*) blockCallingPartyNumberCapability
| read atomic assign

A capability object indicating whether the block calling party number feature is available.

- (CSCapability*) callbackCallCapability
| read atomic assign

Returns a capability object indicating whether the user is able to invoke callback calls.

- (CSCapability*) callForwardingBusyNoAnswerCapability
| read atomic assign

A capability object indicating whether the call forwarding busy-no-answer feature is available for the user's local extension.

- (NSString*) callForwardingBusyNoAnswerDestination
| read atomic assign

The call forwarding busy-no-answer destination for the user's local extension, if any.

- (BOOL) callForwardingBusyNoAnswerEnabled
| read atomic assign

A Boolean value indicating whether the call forwarding busy-no-answer feature is enabled for the user's local extension.

- (CSCapability*) callForwardingCapability
| read atomic assign

A capability object indicating whether the call forwarding feature is available for the user's local extension.

- (NSString*) callForwardingDestination
| read atomic assign

The call forwarding destination for the user's local extension, if any.

- (BOOL) callForwardingEnabled
| read atomic assign

A Boolean value indicating whether the call forwarding feature is enabled for the user's local extension.

- (id<CSCallFeatureServiceDelegate>) delegate
| read write nonatomic weak

The delegate responsible for handling call feature events.

- (CSCapability*) EC500Capability
| read atomic assign

A capability object indicating whether the EC500 feature is available.

- (BOOL) EC500Enabled
| read atomic assign

A Boolean value indicating whether the EC500 feature is enabled.

- (CSCapability*) enhancedCallForwardingCapability
| read atomic assign

A capability object indicating whether the Enhanced Call Forwarding feature is available for the user's local extension.

- (CSEnhancedCallForwardingStatus*) enhancedCallForwardingStatus
| read nonatomic assign

The Enhanced Call Forwarding status for the user's local extension, if any.

- (CSCapability*) exclusionCapability
| read atomic assign

A capability object indicating whether the exclusion feature is available.

- (CSCapability*) extendCallCapability
| read atomic assign

A capability object indicating whether the extend call feature is available.

- (BOOL) internalTwinningEnabled
| read atomic assign

A Boolean value indicating whether the internal twinning feature is enabled.

- (BOOL) isServiceAvailable
| read nonatomic assign

A Boolean value indicating whether the Call Feature Service is available.

Returns
  YES if the Call Feature Service is available, NO otherwise.

- (CSCapability*) limitCallsCapability
| read atomic assign

A capability object indicating whether the Limit Number of Concurrent Calls feature is available.

- (BOOL) maliciousCallTraceActive
| read atomic assign

A Boolean value indicating whether Malicious Call Trace feature is activated.

- (CSCapability*) maliciousCallTraceCapability
| read atomic assign

A capability object indicating whether Malicious Call Trace feature is available for incoming active call.

- (CSCapability*) noHoldConferenceCancelCapability
| read atomic assign

A capability object indicating whether No Hold Conference feature can be canceled.

- (CSCapability*) noHoldConferenceCapability
| read atomic assign

A capability object indicating whether No Hold Conference feature is available for active call.

- (NSString*) noHoldConferenceDestination
| read atomic assign

The destination extension for No Hold Conference feature button.

- (CSCapability*) parkCallCapability
| read atomic assign

A capability object indicating whether the call park feature is available.

- (CSCapability*) parkCallWithSlotCapability
| read atomic assign

A capability object indicating whether the call park feature with park slot is available.

- (CSCapability*) pickupCallAtExtensionCapability
| read atomic assign

A capability object indicating whether the directed call pickup feature is available.

- (CSCapability*) pickupCallForGroupCapability
| read atomic assign

A capability object indicating whether the extended group call pickup feature is available.

- (CSCapability*) pickupGroupCallCapability
| read atomic assign

A capability object indicating whether the group call pickup feature is available.

- (CSCapability*) priorityCallCapability
| read atomic assign

A capability object indicating whether the priority call feature is available.

- (CSCapability*) sendAllCallsCapability
| read atomic assign

A capability object indicating whether the send all calls feature is available for the user's local extension.

- (BOOL) sendAllCallsEnabled
| read atomic assign

A Boolean value indicating whether the send all calls feature is enabled for the user's local extension.

- (CSCapability*) sendNNCapability
| read atomic assign

Returns a capability object indicating whether the user is able to invoke send-nn feature.

- (CSCapability*) serviceObservingCapability
| read nonatomic assign

Returns an indication as to whether the service observing is available.

Returns
  CSCapability object describing whether the service observing is available.

- (CSServiceObservingStatusParameters*) serviceObservingStatusParameters
| read nonatomic assign

Returns service observing feature status parameters.

If service observing feature is enabled then the CSServiceObservingStatusParameters object contains details of service observing feature.

See also
  CSServiceObservingStatusParameters

- (CSCapability*) simRingCallbackCapability
| read atomic assign

A capability object indicating whether the user is able to configure callback / simultaneous ring destinations and their parameters.

- (BOOL) simRingCallbackEnabled
| read atomic assign

A Boolean value indicating whether the callback / simultaneous ring feature is enabled.

- (CSSimRingCallbackStatusParameters*) simRingCallbackStatusParameters
| read nonatomic assign

Returns callback / simultaneous ring feature status parameters.

If callback / simultaneous ring feature is enabled then the CSSimRingCallbackStatusParameters object contains details of this feature.

See also
  CSSimRingCallbackStatusParameters

- (NSArray<CSTeamButton *>*) teamButtons
| read nonatomic assign

List of team buttons assigned to the station.

This list represents those addresses/endpoints/users participated in this leg of the call and does not represent the union of all users who participated in this call. The local user may have conversed with those remoteParticipants listed in callEvents records.

See also
  CSCallFeatureService::didChangeTeamButtons:

- (CSCapability*) unblockCallingPartyNumberCapability
| read atomic assign

A capability object indicating whether the unblock calling party number feature is available.

- (CSCapability*) unparkCallCapability
| read atomic assign

A capability object indicating whether the call unpark feature with slot number is available.

- (CSCapability*) unparkCallWithSlotCapability
| read atomic assign

A capability object indicating whether the call unpark feature with park slot is available.

- (CSCapability*) whisperPageCapability
| read atomic assign

A capability object indicating whether the whisper page feature is available.

The documentation for this class was generated from the following file:

- CSCallFeatureService.h